#include <stdio.h>
#include <ldap.h>

#define FILTERFILE	"/tmp/getfilter.conf"
#define SEARCHBASE	"o=Netscape Communications Corp., c=US"

main( int argc, char **argv )
{
	LDAP		*ld;
	LDAPMessage	*result;
	LDAPFiltInfo	*fi;
	LDAPFiltDesc	*fd;
	int		matches;

	if ( argc != 2 ) {
		fprintf( stderr, "usage: %s searchstring\n", argv[0] );
		exit( 1 );
	}
	if ( (ld = ldap_init( "ggood", LDAP_PORT ))
	   == NULL ) {
		perror( "ldap_init" );
		exit( 1 );
	}
	if ( ldap_simple_bind_s( ld, NULL, NULL ) != LDAP_SUCCESS ) {
		ldap_perror( ld, "ldap_simple_bind_s" );
		exit( 1 );
	}
	if ( (fd = ldap_init_getfilter( FILTERFILE )) == NULL ) {
		perror( FILTERFILE );
		exit( 1 );
	}
	for ( fi = ldap_getfirstfilter( fd, "myapp", argv[1] );
	   fi != NULL; fi = ldap_getnextfilter( fd ) ) {
		if ( ldap_search_s( ld, SEARCHBASE, LDAP_SCOPE_SUBTREE,
		   fi->lfi_filter, NULL, 0, &result )
		   != LDAP_SUCCESS ) {
			ldap_perror( ld, "ldap_search_s" );
			exit( 1 );
		}
		if ( (matches = ldap_count_entries( ld, result ))
		   != 0 ) {
			printf( "Found %d matches with filter \"%s\"\n",
			    matches, fi->lfi_filter );
			return( 0 );
		}
		ldap_msgfree( result );
	}
	printf( "Could not find any matches for \"%s\"\n", argv[1] );
	return( 1 );
}
