#ifdef TEST
#include <stdio.h>
#include <ldap.h>
#endif

void
print_leading_components( char *dn, int limit )
{
	char	**comps;
	int	i;

	if ( (comps = ldap_explode_dn( dn, 1 )) == NULL ) {
		return;
	}

	for ( i = 0; i < limit && comps[ i ] != NULL; ++i ) {
		printf( "%s%s", ( i > 0 ? ", " : "" ), comps[ i ] );
	}
	putchar( '\n' );

	ldap_value_free( comps );
}


#ifdef TEST

main( int argc, char **argv )
{
	int		i, limit;
	char		*dn;

	if ( argc != 3 ) {
		fprintf( stderr, "%s: DN limit\n", argv[ 0 ] );
		exit( 1 );
	}

	dn = argv[ 1 ];
	limit = atoi( argv[ 2 ] );

	printf( "print_leading_components( %s, %d ):\n\t", dn, limit );
	print_leading_components( dn, limit );

	exit( 0 );
}
#endif /* TEST */
