#include <stdio.h>
#include <sys/stat.h>
#include <ldap.h>
 
#define ENTRYDN		"cn=Barbara Jensen, o=Ace Industry, c=US"
#define ENTRYPW		"hifalutin"
#define PHOTOFILE	"/tmp/babs.jpg"
 
main( int argc, char **argv )
{
	LDAP		*ld;
	LDAPMessage	*result;
	LDAPMod		photomod, mailmod;
	LDAPMod		*mods[3];
	char		*buf;
	struct berval	photobv;
	struct berval	*photobvals[2];
	char		*mailvals[2];
	struct stat	st;
	FILE		*fp;
	int		msgid, rc;
	struct timeval	tv;
 
	if ( (ld = ldap_init( "ggood", LDAP_PORT ))
	   == NULL) {
		perror( "ldap_init" );
		exit( 1 );
	}
 
	if ( ldap_simple_bind_s( ld, ENTRYDN, ENTRYPW )
	    != LDAP_SUCCESS ) {
		ldap_perror( ld, "ldap_simple_bind_s" );
		exit( 1 );
	}
 
	if ( stat( PHOTOFILE, &st ) != 0
	    || (fp = fopen( PHOTOFILE, "rb" )) == NULL ) {
		perror( PHOTOFILE );
		exit( 1 );
	}
	if ( (buf = (char *) malloc( st.st_size )) == NULL
	    || fread( buf, st.st_size, 1, fp ) != 1 ) {
		perror( buf ? "fread" : "malloc" );
		exit( 1 );
	}
	fclose( fp );
 
	/* photograph modification */
	photobv.bv_len = st.st_size;
	photobv.bv_val = buf;
	photobvals[0] = &photobv;
	photobvals[1] = NULL;
	photomod.mod_op = LDAP_MOD_REPLACE | LDAP_MOD_BVALUES;
	photomod.mod_type = "jpegphoto";
	photomod.mod_bvalues = photobvals;
	/* email modification */
	mailvals[0] = "babs@ace.com";
	mailvals[1] = NULL;
	mailmod.mod_op = LDAP_MOD_REPLACE;
	mailmod.mod_type = "mail";
	mailmod.mod_values = mailvals;
	/* make the list of mods */
	mods[0] = &photomod;
	mods[1] = &mailmod;
	mods[2] = NULL;
 
	/* initiate the modification */
	if ( (msgid = ldap_modify( ld, ENTRYDN, mods )) == -1 ) {
		ldap_perror( ld, "ldap_modify" );
		exit( 1 );
	}
	free( buf );
 
	tv.tv_sec = 0;
	tv.tv_usec = 100;
	while ( (rc = ldap_result( ld, msgid, 0, &tv, &result ))
	    == 0 ) {
		printf( "waiting...\n" );
	}
	ldap_result2error( ld, result, 1 );
	ldap_perror( ld, "ldap_modify" );
 
	ldap_unbind( ld );
	return( 0 );
}
