#include <stdio.h>
#include <ldap.h>
 
#define ADMINDN	"cn=Directory Admin, o=Ace Industry, c=US"
#define ADMINPW	"secret"
#define ENTRYDN	"cn=Bjorn Jensen, o=Ace Industry, c=US"
 
main( int argc, char **argv )
{
	LDAP	*ld;
	char	*cnvals[2], *snvals[2], *ocvals[2];
	LDAPMod	cnmod, snmod, ocmod;
	LDAPMod	*mods[4];
 
	/* initialize the LDAP session */
	if ( (ld = ldap_init( "ggood", LDAP_PORT ))
	   == NULL) {
		perror( "ldap_init" );
		exit( 1 );
	}
 
	/* authenticate to the LDAP server */
	if ( ldap_simple_bind_s( ld, ADMINDN, ADMINPW )
	    != LDAP_SUCCESS ) {
		ldap_perror( ld, "ldap_simple_bind_s" );
		exit( 1 );
	}
 
	/* construct the entry to add */
	cnvals[0] = "Bjorn Jensen";
	cnvals[1] = NULL;
	cnmod.mod_op = 0;
	cnmod.mod_type = "cn";
	cnmod.mod_values = cnvals;
	snvals[0] = "Jensen";
	snvals[1] = NULL;
	snmod.mod_op = 0;
	snmod.mod_type = "sn";
	snmod.mod_values = snvals;
	ocvals[0] = "top";
	ocvals[1] = "person";
	ocvals[2] = NULL;
	ocmod.mod_op = 0;
	ocmod.mod_type = "objectclass";
	ocmod.mod_values = ocvals;
	mods[0] = &cnmod;
	mods[1] = &snmod;
	mods[2] = &ocmod;
	mods[3] = NULL;
 
	/* make the modification */
	if ( ldap_add_s( ld, ENTRYDN, mods ) != LDAP_SUCCESS ) {
		ldap_perror( ld, "ldap_add_s" );
		exit( 1 );
	}
 
	/* clean up */
	ldap_unbind( ld );
	return( 0 );
}
